define MusicPlayM = [("BathroomLevel", "_7AM"),
("ToiletLevel", "_8AM"),
("MBedroomLevel", "_9AM"),
("SPoolLvl", "_3PMM"),
("PoolLvl", "_4PMM"),
("KitchenLevel", "_5PM"),
("BathroomLevel", "_7PM"),
("LoungeLvl", "_8PM"),
("MBedroomLevel", "_9PM"),
("MBedroomLevel", "_10PM"),
("MBedroomLevel", "_11PM"),
("MBedroomLevel", "_12AM")]

define MusicPlayS = [("ToiletLevel", "_7AM"),
("BathroomLevel", "_8AM"),
("SBedroomLevel", "_9AM"),
("PoolMSLvl", "S3PM"),
("SPoolLvl", "_3PMS"),
("PoolLvl", "_4PMS"),
("SBedroomLevel", "_5PM"),
("KitchenLevel", "_7PM"),
("BathroomLevel", "_8PM"),
("LoungeLvl", "_9PM"),
("SBedroomLevel", "_10PM"),
("SBedroomLevel", "_11PM"),
("SBedroomLevel", "_12AM")]

define MusicPlayMS = [("PoolLvl", "_2PM"),
("LoungeLvl", "_6PM"),
("LoungeLvlup", ""),
("GoodbyeLvl", "")]

init -1 python:
    import math
    renpy.music.register_channel("musicM", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicS", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicZ", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicDORO", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicHazel", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicEve", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicJane", "music", True, tight=True, framedrop=False, buffer_queue=True)
    renpy.music.register_channel("musicMain", "music", True, tight=True, framedrop=False, buffer_queue=True)

    if renpy.variant("pc"):
        config.default_music_volume = 0.3
        config.default_sfx_volume = 0.3
        config.default_voice_volume = 0.3
    else:
        config.default_music_volume = 0.0
        config.default_sfx_volume = 0.0
        config.default_voice_volume = 0.0

    def initMusicMSPlay(Label):
        if not renpy.music.is_playing("musicMain"):
            renpy.music.play("Audio/map_base.ogg", "musicMain", synchro_start=True)
        if Label == "NeighborIntro":
            initMusicStopChannels()
            renpy.music.stop("musicMain")
            renpy.music.play("Audio/donnarose_theme.ogg", channel="musicDORO", fadein=3)
        elif Location == "Store":
            initMusicStopChannels()
            renpy.music.stop("musicMain")
            renpy.music.play("Audio/laura.ogg", channel="musicDORO", fadein=3)
        elif Location == "CoffeeShop":
            initMusicStopChannels()
            renpy.music.stop("musicMain")
            renpy.music.play("Audio/hazel.ogg", channel="musicHazel", fadein=3)
        elif Location == "Motel":
            initMusicStopChannels()
            renpy.music.stop("musicMain")
            renpy.music.play("Audio/eve.ogg", channel="musicEve", fadein=3)
        elif Location == "JaneApt":
            initMusicStopChannels()
            renpy.music.stop("musicMain")
            renpy.music.play("Audio/Jane.ogg", channel="musicJane", fadein=3)
        for i in MusicPlayM:
            if Label == i[0] + str(Sarah.Relationship) + i[1]:
                initMusicStopChannels()
                if initMusicPosMain() != "None":
                    renpy.music.play("<from " + initMusicPosMain() + " loop 0.0>Audio/map_main_M.ogg", channel="musicM", fadein=3)
        for i in MusicPlayS:
            if Label == i[0] + str(Shannon.Relationship) + i[1]:
                initMusicStopChannels()
                if initMusicPosMain() != "None":
                    renpy.music.play("<from " + initMusicPosMain() + " loop 0.0>Audio/map_main_S.ogg", channel="musicS", fadein=3)
        for i in MusicPlayMS:
            if Label == i[0] + str(Sarah.Relationship) + i[1]:
                initMusicStopChannels()
                if initMusicPosMain() != "None":
                    renpy.music.play("<from " + initMusicPosMain() + " loop 0.0>Audio/map_main_S.ogg", channel="musicS", fadein=3)
                    renpy.music.play("<from " + initMusicPosMain() + " loop 0.0>Audio/map_main_M.ogg", channel="musicM", fadein=3)
        renpy.music.set_volume(volume=0.5, channel="musicM")
        renpy.music.set_volume(volume=0.5, channel="musicS")
        renpy.music.set_volume(volume=0.5, channel="musicZ")
        renpy.music.set_volume(volume=0.5, channel="musicDORO")
        renpy.music.set_volume(volume=0.5, channel="musicEve")
        renpy.music.set_volume(volume=0.5, channel="musicHazel")
        renpy.music.set_volume(volume=0.5, channel="musicJane")
        return

    def initMusicStopChannels():
        renpy.music.stop("musicZ")
        renpy.music.stop("musicM")
        renpy.music.stop("musicS")
        renpy.music.stop("musicDORO")
        renpy.music.stop("musicEve")
        renpy.music.stop("musicJane")
        renpy.music.stop("musicHazel")

    def initMusicSync():
        if renpy.music.is_playing("musicM"):
            if renpy.music.get_pos("musicMain") != renpy.music.get_pos("musicM"):
                renpy.music.stop("musicM")
                if initMusicPosMain() != "None":
                    renpy.music.play("<from " + initMusicPosMain() + " loop 0.0>Audio/map_main_M.ogg", channel="musicM", fadein=3)
        if renpy.music.is_playing("musicS"):
            if renpy.music.get_pos("musicMain") != renpy.music.get_pos("musicS"):
                renpy.music.stop("musicS")
                if initMusicPosMain() != "None":
                    renpy.music.play("<from " + initMusicPosMain() + " loop 0.0>Audio/map_main_S.ogg", channel="musicS", fadein=3)

    def initMusicMSStop():
        renpy.sound.stop()
        if PreviousLocation == "Map":
            if str(Hour) + Timeday in ["8PM", "9PM", "10PM", "11PM", "12AM"]:
                if renpy.music.get_playing("musicMain") != "Audio/town_map_night.ogg":
                    renpy.music.stop("musicMain")
                    renpy.music.play("Audio/town_map_night.ogg", channel="musicMain", fadein=3)
            else:
                if renpy.music.get_playing("musicMain") != "Audio/town_map_day.ogg":
                    renpy.music.stop("musicMain")
                    renpy.music.play("Audio/town_map_day.ogg", channel="musicMain", fadein=3)
        elif PreviousLocation == "Office":
            if renpy.music.get_playing("musicMain") != "Audio/office_theme.ogg":
                renpy.music.stop("musicMain")
                renpy.music.play("Audio/office_theme.ogg", channel="musicMain", fadein=3)
        elif PreviousLocation == "School":
            if renpy.music.get_playing("musicMain") != "Audio/school.ogg":
                renpy.music.stop("musicMain")
                renpy.music.play("Audio/school.ogg", channel="musicMain", fadein=3)
        elif PreviousLocation == "Spa":
            if renpy.music.get_playing("musicMain") != "Audio/Weekend Event - Spa.ogg":
                renpy.music.stop("musicMain")
                renpy.music.play("Audio/Weekend Event - Spa.ogg", channel="musicMain", fadein=3)
        elif PreviousLocation == "Cabin":
            if renpy.music.get_playing("musicMain") != "Audio/MS_combined.ogg":
                renpy.music.stop("musicMain")
                renpy.music.play("Audio/MS_combined.ogg", channel="musicMain", fadein=3)
        else:
            if renpy.music.get_playing("musicMain") != "Audio/map_base.ogg":
                renpy.music.stop("musicMain")
                renpy.music.play("Audio/map_base.ogg", "musicMain", synchro_start=True, fadein=3)
        renpy.music.stop("music")
        renpy.music.stop("musicM", 3)
        renpy.music.stop("musicS", 3)
        renpy.music.stop("musicZ", 3)
        renpy.music.stop("musicDORO", 3)
        renpy.music.stop("musicEve")
        renpy.music.stop("musicJane")
        renpy.music.stop("musicHazel")
        return

    def initMusicPosMain():
        return str(renpy.music.get_pos("musicMain"))
